/*
 * payload.S -- Adds system call 8 code on custom firmware
 * 
 * It contains hermes v4 parts of code
 */

#include "firmware_symbols.h"

#define ENABLE_HERMES_RESIDENT 0 //Hermes mode or sys36-mode
#define ENABLE_LV2_HERMES 0 //lv2 open/read
#define ENABLE_SYS36_HERMES 0 // syscall36
#define ENABLE_HOOK_HERMES 0 //use hook open modded by hermes

/*
[23:05] <@flukes1> 3.55 - syscall 8 should be changed to 39 60 00 72 44 00 00 22
[23:05] <@flukes1> 8000000000019354 = 39 60 00 72 44 00 00 22
[23:06] <@flukes1> that makes it call hvsc 114
 3.41 - 0x17CD4
*/
#define DESTINATION_HERMES     0x7FF000
#define DESTINATION_SYSCALL36  0x2BE4A0 
#define DESTINATION_PL3        0x00EF48

#if ENABLE_HERMES_RESIDENT
    #define BASE (DESTINATION_HERMES-(resident_code-destination_code))
#else
    #define BASE DESTINATION_HERMES //syscall36 position?
#endif

//possible 3.55 position :?
#define USER_DATA 0x8000000000464198

#define SYS8_VERSION 0x100
#define PERM_MODE 2  // 0 -> restricted 1-> original 2-> new for some games

//hermes functions

// Absolute branching
#define ABS(target) ((target) - (BASE) - .)

// Dynamic macros to load a label into a register
#define MEM_BASE(dest) \
	li      dest, 1; \
	rldicr  dest, dest, 63, 0;
#define LOAD_LABEL(dest, source, address) \
	oris	dest, source, ((BASE) + (address))@h; \
	ori		dest, dest, ((BASE) + (address))@l;

#define LOADI_LABEL(dest, address) LOAD_LABEL(dest, dest, address)

// For loading an absolute value
#define LOAD_ABS(dest, source, address)  \
	oris	dest, source, ((address))@h; \
	ori		dest, dest, ((address))@l;

#define LOADI_ABS(dest, address) LOAD_ABS(dest, dest, address)
// Absolute .quads
#define QUAD_ABS(address) .quad 0x8000000000000000 + BASE + address


/* Patch Table Macros */
#define PATCH_INST(offset, instruction...) .long offset; instruction
#define PATCH_DATA(offset, data...) .long offset; .long data
#define PATCH_BRANCH(offset, op, target) .long offset; op (. + (target - offset))


.org 0
//aDS016lx016llx0:.string	"%d%s%016lx%016llx%016llx%s%s%08x%d%1d%1d%1dAAA\n"

#if ENABLE_HERMES_RESIDENT 
destination_code:


# copy code and jump to main
 exploit_entry: 

    b       payload_install
    .byte 'H', 'S', 'C','8'

payload_install:
//install and patches ?

    //exploit
	li      %r5, 0x1000		#t_u64 size_bytes_r5 = 0x1000 / 4096
	li      %r4, 1			
	rldicr  %r4, %r4, 63,0
	oris	%r4, %r4, (BASE)@h // dest addr
	ori	    %r4, %r4, (BASE)@l
		
copy_to_dest:                             
	
	addi    %r5, %r5, -8
	ldx     %r6, %r3, %r5
	stdx    %r6, %r4, %r5
	cmpldi  %r5, 0
	bne     copy_to_dest
	addi    %r4, %r4, (exploit_main)@l  # load exploit_main addr
	mtctr   %r4		 # jump dest_addr exploit main
	bctr

exploit_main:

	mflr    %r0
	stdu    %sp, -0xA0(%sp)
	std     %r27, 0x78(%sp)
	std     %r28, 0x80(%sp)
	std     %r29, 0x88(%sp)
	std     %r30, 0x90(%sp)
	std     %r31, 0x98(%sp)
	std     %r0, 0xB0(%sp)
	MEM_BASE(%r31)
      
	mr      %r4, %r31
	LOADI_ABS(%r4, SYSCALL_TABLE)

#if ENABLE_SYS36_HERMES
	# syscall 36 
	mr      %r3, %r31
	LOADI_LABEL(%r3, syscall36_desc)
	std     %r3, 36*8(%r4)
#endif
    
	mr      %r5, %r31
	LOADI_LABEL(%r5, patch_table_data)

zero_payload:
// remove patches and no resident code.
// memset 0 from  BASE to DESTINATION
#if 1
	ld	    %r27, 0x78(%sp)
	ld	    %r28, 0x80(%sp)
	ld	    %r29, 0x88(%sp)
	ld  	%r30, 0x90(%sp)
	ld	    %r31, 0x98(%sp)
	ld	    %r0,  0xb0(%sp)
	addi	%sp, %sp, 0xa0
	mtlr	%r0
	
	MEM_BASE(%r3)
	oris	%r3, %r3, (BASE)@h
	ori	    %r3, %r3, (BASE)@l
	li	    %r4, 0
	li	    %r5, (resident_code)@l
	b	    ABS(memset)
#endif

patch_table_data:
//patches on the fly :D

#if ENABLE_HOOK_HERMES
	PATCH_BRANCH(/*0x2aafc8*/ 0x2AAFF0, b, (BASE+(vsh_hook_open-destination_code))) // vsh_open_hook_desc
#endif

    //errr not too much comments, thx
   	//PATCH_INST(0x04ed18, li %r4, 0)
	//PATCH_INST(0x04ed1c, stw %r4, 0(%r3))
	//PATCH_INST(0x04ed20, blr)
	//PATCH_DATA(0x3ba890, 0x01000000)

// syscalls patch
    PATCH_INST(/*0x17CE0*/ 0x19360, lis %r3, -0x7FFF) // restore syscall 9 (used to call this payload)
    PATCH_INST(/*0x17CE4*/ 0x19364, ori %r3, %r3, 3) //tested ok on 3.55

	PATCH_BRANCH(/*0x17CD4*/ 0x19354, b, (BASE+(syscall8-destination_code))) // syscall 8

#if ENABLE_LV2_HERMES
    //from lv2 patcher 3.55
    //#define HVSC_SYSCALL                    811                     // which syscall to overwrite with hvsc redirect
    //#define HVSC_SYSCALL_ADDR               0x8000000000195540ULL   // where above syscall is in lv2
    //#define NEW_POKE_SYSCALL                813                     // which syscall to overwrite with new poke
    //#define NEW_POKE_SYSCALL_ADDR           0x8000000000195A68ULL   // where above syscall is in lv2

    //could be? (3.55)
    //0000195130  F8 21 FE 51  7C 08 02 A6  FB 21 01 78  FB C1 01 A0  7C 79 1B 78  EB C2 FE 28! 38 60 03 21      .!.Q|....!.x....|y.x...(8`.!
    //000019514C  FA 41 01 40  FB 01 01 70  FB 41 01 80  FB 61 01 88  FB A1 01 98  FB E1 01 A8  F8 01 01 C0      .A.@...p.A...a.....    
    //3.41
    //00001BB004  F8 21 FE 51  7C 08 02 A6  FB 21 01 78  FB C1 01 A0  7C 79 1B 78  EB C2 05 40! 38 60 03 21      .!.Q|....!.x....|y.x...@8`.!
    //00001BB020  FA 41 01 40  FB 01 01 70  FB 41 01 80  FB 61 01 88  FB A1 01 98  FB E1 01 A8  F8 01 01 C0      .A.@...p.A...a..............
    PATCH_BRANCH(/*0x1BB004*/ 0x195130, b, (BASE+(lv2_open-destination_code))) // syscall 0x801

    //could be? (3.55)
    //000019031C  F8 21 FE F1  7C 08 02 A6  FB A1 00 F8  7C 7D 1B 78  38 60 00 00  F8 01 01 20  FB 21 00 D8      .!..|.......|}.x8`..... .!..
    //0000190338  FB 41 00 E0  7C B9 2B 78  FB 61 00 E8  FB 81 00 F0  7C 9B 23 78  FB E1 01 08  3B 81 00 88      .A..|.+x.a......|.#x....;...
    //0000190354  7C DF 33 78  4B ED BF E1! 38 80 00 0C  7F 83 E3 78  64 84 80 00  7F BD 07 B4  4B FE F4 B9      |.3xK...8......xd.......K...
    //3.41
    //00001B61F0  F8 21 FE F1  7C 08 02 A6  FB A1 00 F8  7C 7D 1B 78  38 60 00 00  F8 01 01 20  FB 21 00 D8      .!..|.......|}.x8`..... .!..
    //00001B620C  FB 41 00 E0  7C B9 2B 78  FB 61 00 E8  FB 81 00 F0  7C 9B 23 78  FB E1 01 08  3B 81 00 88      .A..|.+x.a......|.#x....;...
    //00001B6228  7C DF 33 78  4B EB 76 09! 38 80 00 0C  7F 83 E3 78  64 84 80 00  7F BD 07 B4  4B FE F4 B9      |.3xK.v.8......xd.......K...
    PATCH_BRANCH(/*0x1B61F0*/ 0x19031C, b, (BASE+(lv2_read-destination_code))) // syscall 0x802
#endif

    //really we need this on 3.55?
	PATCH_INST(/*0x50B3C*/ 0xEF48, li      %r3, 1) # use this patch if you move the payload resident code to other address 
	PATCH_INST(/*0x50B40*/ 0xEF4C, blr)

########################################################################################################################################################
.org 0x1AC //same position like hermes payload - paranoid mode on! XD

resident_code:
#endif //end enable hermes resident

return1:
	li	    %r3, 1
    blr
		 
return0:
	li      %r3, 0
    blr

#if ENABLE_SYS36_HERMES
# 000xxxx
syscall36_desc:
	QUAD_ABS(syscall36)
	.quad USER_DATA //user data on 3.55?
#endif

#sys36

#lv2open

#lv2read

#hook

########################################################################################################################################################
# generic tool main syscall
#if ENABLE_HERMES_RESIDENT
.org 0x81C //same position like hermes payload - paranoid mode on, yep :P
#else
.org 0xd0
		.long 0x80000000
		.long BASE + syscall8

.org 0x100
#endif
syscall8:

	mflr    %r0
	stdu    %sp, -0xA0(%sp)
	std     %r27, 0x78(%sp)
	std     %r28, 0x80(%sp)
	std     %r29, 0x88(%sp)
	std     %r30, 0x90(%sp)
	std     %r31, 0x98(%sp)
	std     %r0, 0xB0(%sp)

	MEM_BASE(%r31)

	LOAD_LABEL(%r27, %r31, save_syscall_values)
	
	lwz     %r28, 0(%r27)	   // stealth mode
	cmplwi  %r28, 0x0
	beq	    syscall8_ok	   // if not stealth mode work normally

	cmplwi  %r28, 8
	bge	    syscall8_stealth // if stealth mode >=8 ignore all
	
	cmpldi  %r3, 1	           // test for command == 1
    bne	    syscall8_stealth

	cmpldi  %r4, 0	           // compare if key is 0 to skip count times
    beq	    syscall8_skip_count

	addi	%r28, %r28, 1	  // stealth_mode++ (count times)
	stw     %r28, 0(%r27)

 syscall8_skip_count:

	ld      %r28,  8(%r27)	   // get key and compares if same key
	cmpld	%r4, %r28
    bne	    syscall8_stealth
	li	    %r28, 1
	stw     %r28, 0(%r27) // stealth mode

// syscall8 enabled: system_call_2(8, 1, key)
	
	LOAD_ABS(%r4, %r31, SYSCALL_TABLE)

	ld      %r28,  16(%r27)
	std     %r28,  6*8(%r4) // patch syscall 6 to enable

	ld      %r28,  24(%r27)
	std     %r28,  7*8(%r4) // patch syscall 7 to enable
#if ENABLE_SYS36_HERMES
	//LOAD_LABEL(%r28, %r31, syscall36_desc)
	//std     %r28, 36*8(%r4) // patch syscall 36 to enable
#endif
	li	    %r28, 0
	stw     %r28, 0(%r27) // stealth mode off
	
	li	    %r3, SYS8_VERSION
	b	    syscall8_end

 syscall8_ok:

// syscall switch

	andi.   %r3, %r3, 0xff
	cmpldi  %r3, 12
	bge	syscall8_unsupported
	
	LOAD_LABEL(%r27, %r31, syscall8_table)
	sldi 	%r28, %r3, 3
	add 	%r27, %r27, %r28
	
	ld	    %r29, 0(%r27)

// move param registers
	mr      %r3, %r4
	mr      %r4, %r5
	mr      %r5, %r6

// jump to register address with link
	bl	    syscall8_bl

 syscall8_end:

	ld      %r27, 0x78(%sp)
    ld      %r28, 0x80(%sp)
    ld      %r29, 0x88(%sp)
    ld      %r30, 0x90(%sp)
    ld      %r31, 0x98(%sp)
    ld      %r0, 0xB0(%sp)
    addi    %sp, %sp, 0xA0
	mtlr    %r0
	blr

 syscall8_stealth:

	lis     %r3, -0x7FFF
	ori     %r3, %r3, 3
	b       syscall8_end

 syscall8_unsupported:

	li     %r3, -1
	b      syscall8_end

 syscall8_bl:

	mtctr   %r29
	bctr

# ---------------------------------------------------------------------------
	// system_call_2(8, 0, key): disables the syscalls vectors and fix a key to enable it again using system_call_2(8, 1, key)
 sys8_disable:

	LOAD_LABEL(%r27, %r31, save_syscall_values)
	std     %r3,  8(%r27) // save key

	li	    %r28, 1
	stw     %r28, 0(%r27) // stealth mode

	LOAD_ABS(%r4, %r31, SYSCALL_TABLE)

	ld      %r3, 37*8(%r4) // get unused syscall addr

	ld      %r28, 6*8(%r4)
	std     %r3,  6*8(%r4) // patch syscall 6 to stealth
	std     %r28,  16(%r27)

	ld      %r28, 7*8(%r4)
	std     %r3,  7*8(%r4) // patch syscall 7 to stealth
	std     %r28,  24(%r27)
	
#if ENABLE_SYS36_HERMES
    std     %r3, 36*8(%r4) // patch syscall 36 to stealth
#endif
	li	    %r3, 0
	blr

      // dummy for system_call_2(8, 1, key)

 sys8_enable: // system_call_2(8, 1, key) when syscalls are enabled

	li	    %r3, SYS8_VERSION
	blr

 sys8_memcpy: // system_call_4(8, 2, dest, src, len)

	b      ABS(memcpy)

 sys8_memset: // system_call_4(8, 3, dest, dat, len)

	b      ABS(memset)

 sys8_call: // system_call_4(8, 4, addr, param1, param2)
	
	mtctr   %r3
	mr	    %r3, %r4
	mr	    %r4, %r5
	bctr

 sys8_alloc: // system_call_3(8, 5, size, pool)

	b      ABS(alloc)

 sys8_free: // system_call_3(8, 6, ptr, pool)

	b      ABS(free)

 sys8_panic: // system_call_1(8, 7)

	li      %r3, 0
	li      %r11, 0xFF
    sc	    1

 sys8_perm_mode: // system_call_2(8, 8, perm)

	LOAD_LABEL(%r27, %r31, perm_mode)
	stw	    %r3, 0(%r27)
	li	    %r3, 0
	blr

 sys8_open_table:  // system_call_2(8, 9, ptr)

	mr	    %r4, %r3
	LOAD_LABEL(%r27, %r31, str_open_cmp)
	ld	    %r3, 0(%r27)
    std	    %r4, 0(%r27)
	blr

##################################################################################

str_open_cmp: //for open path
	.quad 0

save_syscall_values: // (for stealth)
	.quad 0 // stealth mode
	.quad 0 // key
	.quad 0 // syscall 6
	.quad 0 // syscall 7

syscall8_table:
	QUAD_ABS(sys8_disable);
	QUAD_ABS(sys8_enable);
	QUAD_ABS(sys8_memcpy);
	QUAD_ABS(sys8_memset);
	QUAD_ABS(sys8_call);
	QUAD_ABS(sys8_alloc);
	QUAD_ABS(sys8_free);
	QUAD_ABS(sys8_panic);
	QUAD_ABS(sys8_perm_mode);
	QUAD_ABS(sys8_open_table);

perm_mode:
	.long PERM_MODE

#if ENABLE_HERMES_RESIDENT
.org 0xff0
#else
.org 0x400
#endif
